--- old/usr/src/uts/common/fs/tmpfs/tmp_vnops.c	2016-12-05 21:50:23.324431511 +0000
+++ new/usr/src/uts/common/fs/tmpfs/tmp_vnops.c	2016-12-05 21:50:23.335284232 +0000
@@ -1105,8 +1105,7 @@
 
 	if (tp->tn_type != VDIR ||
 	    (error = secpolicy_fs_linkdir(cred, dvp->v_vfsp)) == 0)
-		error = tdirdelete(parent, tp, nm, tp->tn_type == VDIR ?
-		    DR_RMDIR : DR_REMOVE, cred);
+		error = tdirdelete(parent, tp, nm, DR_REMOVE, cred);
 
 	rw_exit(&tp->tn_rwlock);
 	rw_exit(&parent->tn_rwlock);
@@ -1428,20 +1427,6 @@
 		goto done;
 	}
 
-	/*
-	 * Check for an empty directory
-	 * i.e. only includes entries for "." and ".."
-	 */
-	if (self->tn_dirents > 2) {
-		error = EEXIST;		/* SIGH should be ENOTEMPTY */
-		/*
-		 * Update atime because checking tn_dirents is logically
-		 * equivalent to reading the directory
-		 */
-		gethrestime(&self->tn_atime);
-		goto done;
-	}
-
 	error = tdirdelete(parent, self, nm, DR_RMDIR, cred);
 done:
 	vn_vfsunlock(vp);
